/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// ssml - The SSML to be spoken to the call.    clearDigitsBuffer - If true, the digits buffer is cleared before the playback.    stopOnDigit - Tf true, the playback is interrupted by any key pressed.    waitForCompletion - If true, the http request will reply only when the playback will be completed, otherwise a webhook shall be used to be notified on completion.
    /// </summary>
    [DataContract]
        public partial class SpeakSsmlParams :  IEquatable<SpeakSsmlParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpeakSsmlParams" /> class.
        /// </summary>
        /// <param name="ssml">ssml.</param>
        /// <param name="clearDigitsBuffer">clearDigitsBuffer.</param>
        /// <param name="stopOnDigit">stopOnDigit.</param>
        /// <param name="waitForCompletion">waitForCompletion.</param>
        public SpeakSsmlParams(string ssml = default(string), bool? clearDigitsBuffer = default(bool?), bool? stopOnDigit = default(bool?), string? userContext = default(string?), bool? waitForCompletion = default(bool?))
        {
            this.Ssml = ssml;
            this.ClearDigitsBuffer = clearDigitsBuffer;
            this.StopOnDigit = stopOnDigit;
            this.UserContext = userContext;
            this.WaitForCompletion = waitForCompletion;
        }
        
        /// <summary>
        /// Gets or Sets Ssml
        /// </summary>
        [DataMember(Name="ssml", EmitDefaultValue=false)]
        public string Ssml { get; set; }

        /// <summary>
        /// Gets or Sets ClearDigitsBuffer
        /// </summary>
        [DataMember(Name="clearDigitsBuffer", EmitDefaultValue=false)]
        public bool? ClearDigitsBuffer { get; set; }

        /// <summary>
        /// Gets or Sets StopOnDigit
        /// </summary>
        [DataMember(Name="stopOnDigit", EmitDefaultValue=false)]
        public bool? StopOnDigit { get; set; }

        /// <summary>
        /// Gets or Sets UserContext
        /// </summary>
        [DataMember(Name = "userContext", EmitDefaultValue = false)]
        public string UserContext { get; set; }

        /// <summary>
        /// Gets or Sets WaitForCompletion
        /// </summary>
        [DataMember(Name="waitForCompletion", EmitDefaultValue=false)]
        public bool? WaitForCompletion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SpeakSsmlParams {\n");
            sb.Append("  Ssml: ").Append(Ssml).Append("\n");
            sb.Append("  ClearDigitsBuffer: ").Append(ClearDigitsBuffer).Append("\n");
            sb.Append("  StopOnDigit: ").Append(StopOnDigit).Append("\n");
            sb.Append("  UserContext: ").Append(UserContext).Append("\n");
            sb.Append("  WaitForCompletion: ").Append(WaitForCompletion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SpeakSsmlParams);
        }

        /// <summary>
        /// Returns true if SpeakSsmlParams instances are equal
        /// </summary>
        /// <param name="input">Instance of SpeakSsmlParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SpeakSsmlParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Ssml == input.Ssml ||
                    (this.Ssml != null &&
                    this.Ssml.Equals(input.Ssml))
                ) && 
                (
                    this.ClearDigitsBuffer == input.ClearDigitsBuffer ||
                    (this.ClearDigitsBuffer != null &&
                    this.ClearDigitsBuffer.Equals(input.ClearDigitsBuffer))
                ) && 
                (
                    this.StopOnDigit == input.StopOnDigit ||
                    (this.StopOnDigit != null &&
                    this.StopOnDigit.Equals(input.StopOnDigit))
                ) && 
                (
                    this.WaitForCompletion == input.WaitForCompletion ||
                    (this.WaitForCompletion != null &&
                    this.WaitForCompletion.Equals(input.WaitForCompletion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Ssml != null)
                    hashCode = hashCode * 59 + this.Ssml.GetHashCode();
                if (this.ClearDigitsBuffer != null)
                    hashCode = hashCode * 59 + this.ClearDigitsBuffer.GetHashCode();
                if (this.StopOnDigit != null)
                    hashCode = hashCode * 59 + this.StopOnDigit.GetHashCode();
                if (this.WaitForCompletion != null)
                    hashCode = hashCode * 59 + this.WaitForCompletion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
